-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPals_CoreUtils(b, b1, b2, b3, b4, b5)
-- DESC : This makes everything happen
-- **************************************************************************
function TitanPanelPals_CoreUtils(b, b1, b2, b3, b4, b5)
     if ( TitanPals["Debug"] ) then
          if ( b ) then TitanPals["dLine"] = "[|cffff9900"..b.."|r]" end
          if ( b1 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b1.."|r]" end
          if ( b2 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b2.."|r]" end
          if ( b3 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b3.."|r]" end
          if ( b4 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b4.."|r]" end
          if ( b5 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b5.."|r]" end
          TitanPals["dLine"] = "Recieved "..TitanPals["dLine"];
	  TitanPanelPals_DebugUtils("bug", "dLine", TitanPals["dLine"]);
     end
     if ( b == "UpDate" ) then
          -- [b     ][b1     ][b2   ][b3    ]
          -- [Action][Faction][Realm][Player]
          local NumPals = GetNumFriends();
	  local Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno, noteAL;
	  for fIndex=1, NumPals do
	       --[Name][Level][Class][Area][Connected][Status][Note]
	       Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno = GetFriendInfo(fIndex);
	       local opl, opc, opno;
	       if ( TitanPals["Lists"][TitanPals["palsDB"]][Palsn] ) then
	            opl, opc, opno = string.match(TitanPals["Lists"][TitanPals["palsDB"]][Palsn], '(.*):(.*):(.*)');
                    if ( not Palsco ) then 
		         Palsl = opl;
                         Palsc = opc;
			 Palsno = opno;
                    end
	       end
	       if ( not Palsno ) then Palsno = ":na"; 
	       else Palsno = ":"..Palsno; end

	       noteAL = Palsl..":"..Palsc..Palsno;
               TitanPals["Lists"][TitanPals["palsDB"]][Palsn] = noteAL;
	  end
	  TitanPanelPals_DebugUtils("bug", "UpDate", "Array Count - "..table.getn(TitanPals["Lists"][TitanPals["palsDB"]]))
     elseif ( b == "NamePlate" ) then
          --[b     ][b1    ][b2   ][b3   ][b4  ]
          --[Action][Status][Level][Class][Name]
          if ( b1 ) then b1 = b1.." "; end
          if ( b2 == 0 ) then b2 = "-"; end
          if ( TitanPals["ShowClass"] ) then
               return "  "..b1.." ("..TitanPanelPals_ColorUtils("GetCText", "orange", b2).." "..TitanPanelPals_ColorUtils("GetCClass", "color", b3, b3)..") "..b4;
          else
               return "  "..b1.."("..TitanPanelPals_ColorUtils("GetCText", "orange", b2)..") "..TitanPanelPals_ColorUtils("GetCClass", "color", b3, b4);
          end
     elseif ( b == "Toggle" ) then
          --[b      ][b1 ]
	  --[Action][Var]
          if ( TitanPals[b1] ) then 
	       TitanPals[b1] = false;
	       if ( b1 == "DebugLogEvent" ) then wipe(TitanPals["Temp"]); end
	       if ( b1 == "Debug") then TitanPals["dLine"] = ""; end
          elseif ( not TitanPals[b1] ) then TitanPals[b1] = true; end
     elseif ( b == "mem" ) then
          --[b     ]
	  --[Action]
          UpdateAddOnMemoryUsage();
          TitanPals["dLine"] = TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb");
          TitanPanelPals_DebugUtils("info", "mem", "Titan Panel [|cffeda55fPals|r] is using "..TitanPals["dLine"].." of memory");
     elseif ( b == "playList" ) then
          --[b     ]
	  --[Action]
          local pTable = TitanPals["Temp"];
          for i=1, table.getn(pTable) do
	       TitanPanelPals_DebugUtils("info", "playList", pTable[i]);
          end
     elseif ( b == "playFriends" ) then
          --[b     ]
	  --[Action]
          local pTable = TitanPals["Lists"][TitanPals["palsDB"]];
          table.foreach(pTable, DEFAULT_CHAT_FRAME:AddMessage("Name = "..k.." Value"..v));
     end
end

-- **************************************************************************
-- NAME : TitanPAnelPals_DebugUtils()
-- DESC : For debug messaging and print messages to chat frame
-- **************************************************************************
function TitanPanelPals_DebugUtils(d, d1, d2)
     --[d     ][d1      ][d2   ]
     --[Action][Function][error]
     if ( d == "bug" and TitanPals["Debug"] ) then
          local iDebug = TitanPanelPals_ColorUtils("GetCText", "red", LB["TITAN_PALS_CORE_DTAG"]);
          if ( d1 ~= "dLine" ) then DEFAULT_CHAT_FRAME:AddMessage(iDebug.."["..TitanPanelPals_ColorUtils("GetCText", "orange", d1).."] "..d2); end
	  if ( TitanPals["DebugLogEvent"] ) then tinsert(TitanPals["Temp"], d2); end
     elseif ( d == "info" ) then
          local iInfo = TitanPanelPals_ColorUtils("GetCText", "orange", LB["TITAN_PALS_CORE_ITAG"]);
	  DEFAULT_CHAT_FRAME:AddMessage(iInfo..d2);
     end
end

-- **************************************************************************
-- NAME : TitanPAnelPals_ColorUtils()
-- DESC : for coloring the tooltip and messages
-- **************************************************************************
function TitanPanelPals_ColorUtils(c, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
     if ( c == "GetCText") then
          --[c     ][c1   ][c2  ]
          --[Action][Color][Text]
          if ( c1 == "gray" ) then return LB["TITAN_PALS_COLORS_GRAY"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "red") then return LB["TITAN_PALS_COLORS_RED"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "green" ) then return LB["TITAN_PALS_COLORS_GREEN"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "orange") then return LB["TITAN_PALS_COLORS_ORANGE"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "normal" ) then return LB["TITAN_PALS_COLORS_NORMAL"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "hlight" ) then return LB["TITAN_PALS_COLORS_HLIGHT"]..c2..LB["TITAN_PALS_COLORS_CTAG"]; end
     elseif ( c == "GetCClass" ) then
          --[c     ][c1   ][c2   ][c3    ]
          --[Action][Style][Class][Player]
          local colorCode;
          if (c2 == LB["TITAN_PALS_CLASSES_WARLOCK"]) then colorCode = "|cff9482C9";
          elseif (c2 == LB["TITAN_PALS_CLASSES_DEATHKNIGHT"]) then colorCode = "|cffc41f3b";
          elseif (c2 == LB["TITAN_PALS_CLASSES_HUNTER"]) then colorCode = "|cffabd473";
          elseif (c2 == LB["TITAN_PALS_CLASSES_PRIEST"]) then colorCode = "|cffffffff";
          elseif (c2 == LB["TITAN_PALS_CLASSES_PALADIN"]) then colorCode = "|cfff58cba";
          elseif (c2 == LB["TITAN_PALS_CLASSES_MAG"]) then colorCode = "|cff69ccf0";
          elseif (c2 == LB["TITAN_PALS_CLASSES_ROGUE"]) then colorCode = "|cfffff569";
          elseif (c2 == LB["TITAN_PALS_CLASSES_DRUID"]) then colorCode = "|cffff7d0a";
          elseif (c2 == LB["TITAN_PALS_CLASSES_SHAMAN"]) then colorCode = "|cff2459FF";
          elseif (c2 == LB["TITAN_PALS_CLASSES_WARRIOR"]) then colorCode = "|cffc79c6e";
          else colorCode = "|cffFFFFFF";
          end
          if ( c1 == "color" ) then return colorCode..c3..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "normal" ) then return c3; end
     end
end